import os.path
import pytz

print 'Configuration file creator for Python SQM standard data format acquisition program'
print 'Only for use of single-channel, fixed, stationary SQM'
print 'Warning! Minimal input check only!'
print 'Please check Documentation for format details.'
devurl = raw_input('Enter device URL/IP address\n')
valid = False
while valid == False:
	try:
		devport = raw_input('Enter TCP port nr. to be used\n')
		if int(devport) < 0 or int(devport) > 65535:
			raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
print 'Is the device SQM-LE?'
sqmle = raw_input('(Enter \'N\' if it is not an SQM-LE)\n')
if sqmle == 'N' or sqmle == 'n':
	devmodel = raw_input('Enter model name of device\n')
	valid = False
	while valid == False:
		try:
			fov = raw_input('Enter field of view of device\n')
			if int(fov) < 0 or int(fov) > 360:	raise ValueError
			else:	valid = True
		except ValueError:	print 'Wrong input! Please try again'
else:
	devmodel = 'SQM-LE'
	fov = '20'
cm500 = raw_input('Does the device use standard filter?\n')
if cm500 == 'N' or cm500 == 'n':
	filtertype = raw_input('Enter type of filter used\n')
else:	filtertype = 'HOYA CM-500'
valid = False
while valid == False:
	try:
		zenith = raw_input('Enter zenith angle of device (between 0 and 180 deg)\n')
		if float(zenith) < 0 or float(zenith) > 180:
			raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
valid = False
while valid == False:
	try:
		azimuth = raw_input('Enter azimuth angle of device (from 0 to <360 deg)\n')
		if float(azimuth) < 0 or float(azimuth) >= 360:
			raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
valid = False
while valid == False:
	try:
		att = raw_input('Enter housing attenuation in MPSAS. Positive value means gain\n')
		float(att)
		valid = True
	except ValueError:	print 'Wrong input! Please try again'
print 'Choosing number of measurements and measurement interval:'
print 'The acquisition program can acquire infinite number of data'
print 'and can be stopped by pressing Ctrl-C. However, it is'
print 'recommended that the program be called by scheduler of OS'
print '(e.g. crontab in Unix-like OSes and task scheduler'
print 'in Windows) so that DAQ can continue in case of'
print 'program crash or connection error\n'
print 'Enter number of DAQs to be made for each call of program'
print '0 means infinite DAQ'
valid = False
while valid == False:
	try:
		n = int(raw_input())
		if n < 0:	raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
if n == 1:	repint = 0
else:
	print 'Enter measurement interval in integer seconds'
	valid = False
	while valid == False:
		try:
			repint = int(raw_input())
			if repint < 0:	raise ValueError
			else:	valid = True
		except ValueError:	print 'Wrong input! Please try again'
valid = False
while valid == False:
	try:
		newfiletime = raw_input('Enter time of day for creating a new file (24 hours format HH:MM)\n')
		if len(newfiletime) != 5:	raise ValueError
		elif int(newfiletime[0:2]) < 0 or int(newfiletime[0:2]) > 23 or	int(newfiletime[3:5]) < 0 or int(newfiletime[3:5]) > 59:
			raise ValueError
		else:
			newfiletime = newfiletime[0:2] + ':' + newfiletime[3:5]
			valid = True
	except ValueError:	print 'Wrong input! Please try again'
print 'Is it (U)TC time or (L)ocal time?'
valid = False
while valid == False:
	try:
		timestamptype = (raw_input()).lower()
		if timestamptype != 'u' and timestamptype != 'l':	raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
print 'Enter IANA timezone name. Please refer to'
print 'http://php.net/manual/en/timezones.php\nor'
print 'http://en.wikipedia.org/wiki/List_of_tz_database_time_zones'
print 'for more information'
valid = False
while valid == False:
	try:
		tzone = raw_input()
		if tzone not in pytz.all_timezones:	raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
timesynctype = raw_input('Enter method of time synchronization (e.g. NTP, GPS)\n')
print 'Enter latitude of site up to four decimal places.'
print 'Use - sign to denote Southern Hemisphere'
valid = False
while valid == False:
	try:
		lat = raw_input()
		if float(lat) > 90 or float(lat) < -90:	raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
print 'Enter longitude of site up to four decimal places.'
print 'Use - sign to denote Western Hemisphere'
valid = False
while valid == False:
	try:
		lon = raw_input()
		if float(lon) > 180 or float(lon) < -180:	raise ValueError
		else:	valid = True
	except ValueError:	print 'Wrong input! Please try again'
valid = False
while valid == False:
	try:
		elev = raw_input('Enter elevation in integer meters\n')
		int(elev)
		valid = True
	except ValueError:	print 'Wrong input! Please try again'
print 'Enter instrument ID. No characters outside of (a-zA-Z0-9_-) are allowed'
valid = False
while valid == False:
	try:
		instid = raw_input()
		for i in range(len(instid)):
			if ((not (instid[i]).isalnum()) and instid[i] != '_' and instid[i] != '-') or instid[i] == ' ' :	raise ValueError
		valid = True
	except ValueError:	print 'Wrong input! Please try again'
locname = raw_input('Enter location name in format Country-(State)-(City)-Location\n')
contactinfo = raw_input('Enter contact information of data supplier\n')
print 'Enter other comments/description for the site'
print 'Maximum 5 lines with 150 characters each:'
comment1 = (raw_input('Line1:\n'))[:150]
comment2 = (raw_input('Line2:\n'))[:150]
comment3 = (raw_input('Line3:\n'))[:150]
comment4 = (raw_input('Line4:\n'))[:150]
comment5 = (raw_input('Line5:\n'))[:150]
f = open(instid+'.inp','w')
f.write(devurl+':'+devport+'\r\n')
f.write(str(n)+','+str(repint)+'\r\n')
f.write(newfiletime+','+timestamptype+'\r\n')
f.write(devmodel+'\r\n')
f.write(instid+'\r\n')
f.write(contactinfo+'\r\n')
f.write(locname+'\r\n')
f.write(lat+','+lon+','+elev+'\r\n')
f.write(tzone+'\r\n')
f.write(timesynctype+'\r\n')
f.write(filtertype+'\r\n')
f.write(zenith+','+azimuth+'\r\n')
f.write(fov+'\r\n')
f.write(att+'\r\n')
f.write(comment1+'\r\n')
f.write(comment2+'\r\n')
f.write(comment3+'\r\n')
f.write(comment4+'\r\n')
f.write(comment5+'\r\n')
f.close()
print 'File '+instid+'.inp created successfully on current directory'
print 'Please refer to Readme file for configuration file format'
print 'when information needs to be changed'
print 'Program will exit now'
